-- Do not edit! Automatically created with doctest-extract from src/Data/Array/Comfort/Shape.hs
{-# LINE 123 "src/Data/Array/Comfort/Shape.hs" #-}

module DocTest.Data.Array.Comfort.Shape where

import Test.DocTest.Base
import qualified Test.DocTest.Driver as DocTest

{-# LINE 124 "src/Data/Array/Comfort/Shape.hs" #-}
import     qualified Data.Array.Comfort.Shape as Shape
import     qualified Data.Map as Map
import     qualified Data.Set as Set
import     Data.Array.Comfort.Shape ((::+)((::+)))

import     Test.ChasingBottoms.IsBottom (isBottom)
import     Control.DeepSeq (rnf)

test :: DocTest.T ()
test = do
 DocTest.printPrefix "Data.Array.Comfort.Shape:311: "
{-# LINE 311 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 311 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices ())
  [ExpectedLine [LineChunk "[()]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:334: "
{-# LINE 334 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 334 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.ZeroBased (7::Int)))
  [ExpectedLine [LineChunk "[0,1,2,3,4,5,6]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:386: "
{-# LINE 386 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 386 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.OneBased (7::Int)))
  [ExpectedLine [LineChunk "[1,2,3,4,5,6,7]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:430: "
{-# LINE 430 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 430 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Range (-5) (5::Int)))
  [ExpectedLine [LineChunk "[-5,-4,-3,-2,-1,0,1,2,3,4,5]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:432: "
{-# LINE 432 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 432 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Range (-1,-1) (1::Int,1::Int)))
  [ExpectedLine [LineChunk "[(-1,-1),(-1,0),(-1,1),(0,-1),(0,0),(0,1),(1,-1),(1,0),(1,1)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:482: "
{-# LINE 482 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 482 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Shifted (-4) (8::Int)))
  [ExpectedLine [LineChunk "[-4,-3,-2,-1,0,1,2,3]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:547: "
{-# LINE 547 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 547 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Enumeration :: Shape.Enumeration Ordering))
  [ExpectedLine [LineChunk "[LT,EQ,GT]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:611: "
{-# LINE 611 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 611 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Set.fromList "comfort"))
  [ExpectedLine [LineChunk "\"cfmort\""]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:647: "
{-# LINE 647 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 647 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ fmap Shape.ZeroBased $ Map.fromList [('b', (0::Int)), ('a', 5), ('c', 2)])
  [ExpectedLine [LineChunk "[('a',0),('a',1),('a',2),('a',3),('a',4),('c',0),('c',1)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:712: "
{-# LINE 712 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 712 "src/Data/Array/Comfort/Shape.hs" #-}
   (
  let sh2 = (Shape.ZeroBased (2::Int), Shape.ZeroBased (2::Int)) in
  let sh3 = (Shape.ZeroBased (3::Int), Shape.ZeroBased (3::Int)) in
  (Shape.offset sh3 $ Shape.indexFromOffset sh2 3,
  Shape.offset (Shape.Deferred sh3) $
  Shape.indexFromOffset (Shape.Deferred sh2) 3)
  )
  [ExpectedLine [LineChunk "(4,3)"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:816: "
{-# LINE 816 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 816 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.ZeroBased (3::Int), Shape.ZeroBased (3::Int)))
  [ExpectedLine [LineChunk "[(0,0),(0,1),(0,2),(1,0),(1,1),(1,2),(2,0),(2,1),(2,2)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:922: "
{-# LINE 922 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 922 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.Square $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[(0,0),(0,1),(0,2),(1,0),(1,1),(1,2),(2,0),(2,1),(2,2)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:976: "
{-# LINE 976 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 976 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.Cube $ Shape.ZeroBased (2::Int))
  [ExpectedLine [LineChunk "[(0,0,0),(0,0,1),(0,1,0),(0,1,1),(1,0,0),(1,0,1),(1,1,0),(1,1,1)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1035: "
{-# LINE 1035 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1035 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.Triangular Shape.Upper $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[(0,0),(0,1),(0,2),(1,1),(1,2),(2,2)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1037: "
{-# LINE 1037 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1037 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.Triangular Shape.Lower $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[(0,0),(1,0),(1,1),(2,0),(2,1),(2,2)]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1169: "
{-# LINE 1169 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1169 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexAscending (replicate 3 Shape.AllDistinct) $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[0,1,2],[0,1,3],[0,2,3],[1,2,3]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1171: "
{-# LINE 1171 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1171 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexAscending (replicate 3 Shape.SomeRepetitive) $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[[0,0,0],[0,0,1],[0,0,2],[0,1,1],[0,1,2],[0,2,2],[1,1,1],[1,1,2],[1,2,2],[2,2,2]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1173: "
{-# LINE 1173 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1173 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexAscending [Shape.Repetitive,Shape.Distinct,Shape.Repetitive] $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[0,0,1],[0,0,2],[0,0,3],[0,1,2],[0,1,3],[0,2,3],[1,1,2],[1,1,3],[1,2,3],[2,2,3]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1175: "
{-# LINE 1175 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1175 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexAscending [Shape.Repetitive,Shape.Distinct,Shape.Distinct] $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[0,0,1],[0,0,2],[0,0,3],[0,1,2],[0,1,3],[0,2,3],[1,1,2],[1,1,3],[1,2,3],[2,2,3]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1178: "
{-# LINE 1178 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1178 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexDescending (replicate 3 Shape.AllDistinct) $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[2,1,0],[3,1,0],[3,2,0],[3,2,1]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1180: "
{-# LINE 1180 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1180 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexDescending (replicate 3 Shape.SomeRepetitive) $ Shape.ZeroBased (3::Int))
  [ExpectedLine [LineChunk "[[0,0,0],[1,0,0],[1,1,0],[1,1,1],[2,0,0],[2,1,0],[2,1,1],[2,2,0],[2,2,1],[2,2,2]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1182: "
{-# LINE 1182 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1182 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexDescending [Shape.Repetitive,Shape.Distinct,Shape.Repetitive] $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[1,1,0],[2,1,0],[2,2,0],[2,2,1],[3,1,0],[3,2,0],[3,2,1],[3,3,0],[3,3,1],[3,3,2]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1184: "
{-# LINE 1184 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1184 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices $ Shape.simplexDescending [Shape.Repetitive,Shape.Distinct,Shape.Distinct] $ Shape.ZeroBased (4::Int))
  [ExpectedLine [LineChunk "[[1,1,0],[2,1,0],[2,2,0],[2,2,1],[3,1,0],[3,2,0],[3,2,1],[3,3,0],[3,3,1],[3,3,2]]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1418: "
{-# LINE 1418 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.property
{-# LINE 1418 "src/Data/Array/Comfort/Shape.hs" #-}
     (let shape = Shape.Cyclic (10::Int) in Shape.offset shape (-1) == Shape.offset shape 9)
 DocTest.printPrefix "Data.Array.Comfort.Shape:1423: "
{-# LINE 1423 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1423 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.Cyclic (7::Int)))
  [ExpectedLine [LineChunk "[0,1,2,3,4,5,6]"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1467: "
{-# LINE 1467 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1467 "src/Data/Array/Comfort/Shape.hs" #-}
   (Shape.indices (Shape.ZeroBased (3::Int) ::+ Shape.Range 'a' 'c'))
  [ExpectedLine [LineChunk "[Left 0,Left 1,Left 2,Right 'a',Right 'b',Right 'c']"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1554: "
{-# LINE 1554 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1554 "src/Data/Array/Comfort/Shape.hs" #-}
   (rnf (Shape.NestedTuple (Shape.Element 1, Shape.Element 2)))
  [ExpectedLine [LineChunk "()"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1556: "
{-# LINE 1556 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1556 "src/Data/Array/Comfort/Shape.hs" #-}
   (rnf (Shape.NestedTuple (Shape.Element 1, (Shape.Element 2, Shape.Element 3))))
  [ExpectedLine [LineChunk "()"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1558: "
{-# LINE 1558 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1558 "src/Data/Array/Comfort/Shape.hs" #-}
   (isBottom $ rnf (Shape.NestedTuple (Shape.Element undefined, Shape.Element 2)))
  [ExpectedLine [LineChunk "True"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1560: "
{-# LINE 1560 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1560 "src/Data/Array/Comfort/Shape.hs" #-}
   (isBottom $ rnf (Shape.NestedTuple (Shape.Element undefined, (Shape.Element 2, Shape.Element 3))))
  [ExpectedLine [LineChunk "True"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1562: "
{-# LINE 1562 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1562 "src/Data/Array/Comfort/Shape.hs" #-}
   (isBottom $ rnf (Shape.NestedTuple (Shape.Element 1, (Shape.Element undefined, Shape.Element 3))))
  [ExpectedLine [LineChunk "True"]]
 DocTest.printPrefix "Data.Array.Comfort.Shape:1564: "
{-# LINE 1564 "src/Data/Array/Comfort/Shape.hs" #-}
 DocTest.example
{-# LINE 1564 "src/Data/Array/Comfort/Shape.hs" #-}
   (isBottom $ rnf (Shape.NestedTuple (Shape.Element 1, (Shape.Element 2, Shape.Element undefined))))
  [ExpectedLine [LineChunk "True"]]
